/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2006, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.worklight.javamenativeapp;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemCommandListener;
import javax.microedition.lcdui.StringItem;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.worklight.wlclient.api.WLClient;
import com.worklight.wlclient.api.WLProcedureInvocationData;
import com.worklight.wlclient.api.WLRequestOptions;

public class JavaMENativeApp extends MIDlet implements CommandListener,ItemCommandListener{
	
	private Display  display;
	private Form form;	
    private StringItem connect;
    private StringItem invoke;
    private static StringItem result;
	private Command exit;
	private WLClient client;
	

	public JavaMENativeApp() {
		client = WLClient.createInstance(this);
		this.display = Display.getDisplay(this);
		form = new Form("JavaME Sample");
		connect = new StringItem("", "1.Connect", Item.BUTTON);
		connect.addCommand(new Command("OK", Command.OK, 1));
		connect.setItemCommandListener(this);
		invoke = new StringItem("","2.Invoke Procedure",Item.BUTTON);
		invoke.addCommand(new Command("OK", Command.OK, 1));
		invoke.setItemCommandListener(this);
		result = new StringItem("", "");
		exit = new Command("Exit", Command.EXIT, 0);
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		notifyDestroyed();

	}

	protected void pauseApp() {

	}

	protected void startApp() throws MIDletStateChangeException {
		form.append(connect);
		form.append(invoke);
		form.append(result);
		form.addCommand(exit);
		form.setCommandListener(this);
		display.setCurrent(form);

	}
	public void commandAction(Command command, Item item) {
		StringItem itemName = (StringItem)item;
		if(itemName.getText().equals("1.Connect")) {
			updateTextView("\nConnecting...");
			client.connect(new MyConnectListener());
		}else if(itemName.getText().equals("2.Invoke Procedure")) {
			updateTextView("\nInvoking procedure...");
			String adapterName = "RSSReader";
			String procedureName = "getFeedsFiltered";
			
			WLProcedureInvocationData invocationData = new WLProcedureInvocationData(adapterName, procedureName);
			
			Object[] parameters = new Object[] {};
			invocationData.setParameters(parameters);
			
			WLRequestOptions options = new WLRequestOptions();	
			client.invokeProcedure(invocationData, new MyInvokeListener(), options);
			  
		  }
	}
	public void commandAction(Command command, Displayable displayable) {
		  String label = command.getLabel();
		  if(label.equals("Exit")) {
			  try{
				  destroyApp(true);
			  }catch(Exception e){
				  
			  }
		  }		
	}
	public static void updateTextView(final String response){
		result.setText(response);		
	}
}
